unit hiNumInWords;

interface

uses Kol,Share;

type
  THINumInWords = class
   private
    FRes:string;
   public
    _prop_Unit1:string;
    _prop_Unit2:string;
    _prop_Unit5:string;
    _prop_Gender:integer;
    _data_Value:THI_Event;
    _event_onResult:THI_Event;

    procedure _work_doConvert(var _Data:TData; Index:word);
  end;

implementation

procedure THINumInWords._work_doConvert;
var
  ones: array [0..19] of string;
  ones1: array [1..2] of string;
  tens: array [0..9] of string;
  hundreds: array [0..9] of string;
  triples: array [0..3,0..2] of string;
  genders: array [0..3] of integer;
  triple,one,ten,hundred,current,gender,padej: integer;
  negative: boolean;
  v: integer;
  res,temp: string;
begin
  ones[0]:='';
  ones[1]:='';
  ones[2]:='';
  ones[3]:='';
  ones[4]:='';
  ones[5]:='';
  ones[6]:='';
  ones[7]:='';
  ones[8]:='';
  ones[9]:='';
  ones[10]:='';
  ones[11]:='';
  ones[12]:='';
  ones[13]:='';
  ones[14]:='';
  ones[15]:='';
  ones[16]:='';
  ones[17]:='';
  ones[18]:='';
  ones[19]:='';
  tens[0]:='';
  tens[1]:='';
  tens[2]:='';
  tens[3]:='';
  tens[4]:='';
  tens[5]:='';
  tens[6]:='';
  tens[7]:='';
  tens[8]:='';
  tens[9]:='';
  hundreds[0]:='';
  hundreds[1]:='';
  hundreds[2]:='';
  hundreds[3]:='';
  hundreds[4]:='';
  hundreds[5]:='';
  hundreds[6]:='';
  hundreds[7]:='';
  hundreds[8]:='';
  hundreds[9]:='';
  triples[0,0]:=_prop_Unit1;
  triples[0,1]:=_prop_Unit2;
  triples[0,2]:=_prop_Unit5;
  triples[1,0]:='';
  triples[1,1]:='';
  triples[1,2]:='';
  triples[2,0]:='';
  triples[2,1]:='';
  triples[2,2]:='';
  triples[3,0]:='';
  triples[3,1]:='';
  triples[3,2]:='';
  genders[0]:=_prop_Gender;
  genders[1]:=1;
  genders[2]:=0;
  genders[3]:=0;
  v:=ReadInteger(_Data,_data_Value,0);
  res:='';
  current:=0;
  negative:=false;
  if v<0 then begin
    negative:=true;
    v:=abs(v);
  end;
  if v=0 then
    res:=''+' '+triples[0,2]
  else begin
    while (v<>0) and (current<4) do begin
      triple:=v mod 1000;
      v:=v div 1000;
      one:=triple mod 10;
      ten:=(triple mod 100) div 10;
      hundred:=triple div 100;
      gender:=genders[current];
      padej:=2;
      if triple=0 then begin
        if current=0 then
          temp:=triples[0,2]
        else
          temp:='';
      end else begin
        if (ten=1) and (one<>0) then begin
          temp:=ones[ten*10+one]+' ';
        end else begin
          case one of
            0: begin
                 temp:='';
               end;
            1: begin
                 case gender of 
                   0: temp:=' ';
                   1: temp:=' ';
                   2: temp:=' ';
                 end;
                 padej:=0;
               end;
            2: begin
                 case gender of
                   0,2: temp:=' ';
                   1: temp:=' ';
                 end;
                 padej:=1;
               end;
            3,4: begin
                   temp:=ones[one]+' ';
                   padej:=1;
                 end;
            else
              begin
                temp:=ones[one]+' ';
              end
          end;
          if ten<>0 then
            temp:=tens[ten]+' '+temp;
        end;
        if hundred<>0 then
          temp:=hundreds[hundred]+' '+temp;
        temp:=temp+triples[current,padej];
      end;
      res:=temp+' '+res;
      inc(current);
    end;
  end;
  if negative then
    res:=' '+res;
  _hi_OnEvent(_event_onResult,res);
end;


end.
